--- old/usr/src/uts/common/inet/udp/udp_stats.c	2015-08-09 12:48:00.122147990 +0300
+++ new/usr/src/uts/common/inet/udp/udp_stats.c	2015-08-09 12:48:00.133230892 +0300
@@ -53,12 +53,16 @@
 	mblk_t			*mpdata;
 	mblk_t			*mp_conn_ctl;
 	mblk_t			*mp_attr_ctl;
+	mblk_t			*mp_pidnode_ctl;
 	mblk_t			*mp6_conn_ctl;
 	mblk_t			*mp6_attr_ctl;
+	mblk_t			*mp6_pidnode_ctl;
 	mblk_t			*mp_conn_tail;
 	mblk_t			*mp_attr_tail;
+	mblk_t			*mp_pidnode_tail;
 	mblk_t			*mp6_conn_tail;
 	mblk_t			*mp6_attr_tail;
+	mblk_t			*mp6_pidnode_tail;
 	struct opthdr		*optp;
 	mib2_udpEntry_t		ude;
 	mib2_udp6Entry_t	ude6;
@@ -78,6 +82,8 @@
 	mib2_udp_t		udp_mib;
 	size_t			udp_mib_size, ude_size, ude6_size;
 
+	conn_pid_node_list_hdr_t	*cph;
+
 
 	/*
 	 * make a copy of the original message
@@ -89,11 +95,16 @@
 	    (mpdata = mpctl->b_cont) == NULL ||
 	    (mp_conn_ctl = copymsg(mpctl)) == NULL ||
 	    (mp_attr_ctl = copymsg(mpctl)) == NULL ||
+	    (mp_pidnode_ctl = copymsg(mpctl)) == NULL ||
 	    (mp6_conn_ctl = copymsg(mpctl)) == NULL ||
-	    (mp6_attr_ctl = copymsg(mpctl)) == NULL) {
+	    (mp6_attr_ctl = copymsg(mpctl)) == NULL ||
+	    (mp6_pidnode_ctl = copymsg(mpctl)) == NULL) {
 		freemsg(mp_conn_ctl);
 		freemsg(mp_attr_ctl);
+		freemsg(mp_pidnode_ctl);
 		freemsg(mp6_conn_ctl);
+		freemsg(mp6_attr_ctl);
+		freemsg(mp6_pidnode_ctl);
 		freemsg(mpctl);
 		freemsg(mp2ctl);
 		return (0);
@@ -135,6 +146,7 @@
 	qreply(q, mpctl);
 
 	mp_conn_tail = mp_attr_tail = mp6_conn_tail = mp6_attr_tail = NULL;
+	mp_pidnode_tail = mp6_pidnode_tail = NULL;
 	v4_conn_idx = v6_conn_idx = 0;
 
 	for (i = 0; i < CONN_G_HASH_SIZE; i++) {
@@ -249,6 +261,18 @@
 
 				(void) snmp_append_data2(mp_conn_ctl->b_cont,
 				    &mp_conn_tail, (char *)&ude, ude_size);
+				/* my data */
+				(void) snmp_append_data2(mp_pidnode_ctl->b_cont,
+				    &mp_pidnode_tail, (char *)&ude, ude_size);
+
+				cph = conn_get_pid_list(connp);
+				(void) snmp_append_data2(mp_pidnode_ctl->b_cont,
+				    &mp_pidnode_tail, (char *)cph,
+				    cph->cph_tot_size);
+
+				kmem_free(cph, cph->cph_tot_size);
+				/* end of my data */
+
 				mlp.tme_connidx = v4_conn_idx++;
 				if (needattr)
 					(void) snmp_append_data2(
@@ -292,6 +316,18 @@
 
 				(void) snmp_append_data2(mp6_conn_ctl->b_cont,
 				    &mp6_conn_tail, (char *)&ude6, ude6_size);
+				/* my dat */
+				(void) snmp_append_data2(
+				    mp6_pidnode_ctl->b_cont, &mp6_pidnode_tail,
+				    (char *)&ude6, ude6_size);
+
+				cph = conn_get_pid_list(connp);
+				(void) snmp_append_data2(
+				    mp6_pidnode_ctl->b_cont, &mp6_pidnode_tail,
+				    (char *)cph, cph->cph_tot_size);
+
+				kmem_free(cph, cph->cph_tot_size);
+				/* end of my data */
 				mlp.tme_connidx = v6_conn_idx++;
 				if (needattr)
 					(void) snmp_append_data2(
@@ -321,6 +357,17 @@
 	else
 		qreply(q, mp_attr_ctl);
 
+	/* table of EXPER_XPORT_PROC_INFO  ipv4 */
+	optp = (struct opthdr *)&mp_pidnode_ctl->b_rptr[
+	    sizeof (struct T_optmgmt_ack)];
+	optp->level = MIB2_UDP;
+	optp->name = EXPER_XPORT_PROC_INFO;
+	optp->len = msgdsize(mp_pidnode_ctl->b_cont);
+	if (optp->len == 0)
+		freemsg(mp_pidnode_ctl);
+	else
+		qreply(q, mp_pidnode_ctl);
+
 	/* IPv6 UDP endpoints */
 	optp = (struct opthdr *)&mp6_conn_ctl->b_rptr[
 	    sizeof (struct T_optmgmt_ack)];
@@ -340,6 +387,17 @@
 	else
 		qreply(q, mp6_attr_ctl);
 
+	/* table of EXPER_XPORT_PROC_INFO  ipv6 */
+	optp = (struct opthdr *)&mp6_pidnode_ctl->b_rptr[
+	    sizeof (struct T_optmgmt_ack)];
+	optp->level = MIB2_UDP6;
+	optp->name = EXPER_XPORT_PROC_INFO;
+	optp->len = msgdsize(mp6_pidnode_ctl->b_cont);
+	if (optp->len == 0)
+		freemsg(mp6_pidnode_ctl);
+	else
+		qreply(q, mp6_pidnode_ctl);
+
 	return (mp2ctl);
 }
 
